moFieldinfos = {};
source(MultiOverlayV3.modDir.."scripte/module/fieldinfos/moFieldinfosConfig.lua");

function moFieldinfos:update(dt)
	--only over manual update (performens)
	if moModule.active.fieldinfos.isRunning then
		if moFieldinfos.values.updateTimer > 0 then
			if MultiOverlayV3.timers["updateFieldinfos"] ~= nil then return;end;
			moSetGetExtras:addTimer( {delay=moFieldinfos.values.updateTimer, name="updateFieldinfos", repeatable=1, ms=false, action=moFieldinfos.load} ); 
		else
			moFieldinfos:load();
		end;
	end;
end;

function moFieldinfos:load(update)
	moFieldinfos:loadFieldinfos(update);	
end;

local test = false;
function moFieldinfos:loadFieldinfos(update)
	local playerFarmId = g_currentMission.player.farmId;	
	moFieldinfos.values.fields = {}; --new
	if g_fieldManager ~= nil and g_fieldManager.fields ~= nil and #g_fieldManager.fields > 0 then
		for a=1, #g_fieldManager.fields do
			local field = g_fieldManager.fields[a];
			if field ~= nil and field.farmland ~= nil then				
				if field.farmland.isOwned and g_farmlandManager:getFarmlandOwner(field.farmland.id) == playerFarmId then
					moFieldinfos.values.fields[#moFieldinfos.values.fields+1] = {};
					local index = #moFieldinfos.values.fields;					
					moFieldinfos.values.fields[index].object = field;
					local fieldSpraySet, sprayFactor, fieldPlowFactor, limeFactor, weedFactor, maxWeedState = MissionManager:getFieldData(field);
					moFieldinfos.values.fields[index].sprayFactor = Utils.getNoNil(string.format("%d %%", sprayFactor * 100), "0%"); --sprayFactor;
					moFieldinfos.values.fields[index].sprayed = Utils.getNoNil(sprayFactor, 0);
					moFieldinfos.values.fields[index].limeFactor = Utils.getNoNil(string.format("%d %%", limeFactor * 100), "0%"); --limeFactor;
					moFieldinfos.values.fields[index].lime = Utils.getNoNil(limeFactor, 0);
					moFieldinfos.values.fields[index].weedFactor = Utils.getNoNil(string.format("%d %%", 100-(weedFactor * 100)), "0%"); --weedFactor;
					moFieldinfos.values.fields[index].weeds = 100-(Utils.getNoNil(weedFactor*100, 0));
					moFieldinfos.values.fields[index].fieldPlowFactor = Utils.getNoNil(string.format("%d %%", fieldPlowFactor * 100), "0"); --fieldPlowFactor;
					moFieldinfos.values.fields[index].plowing = Utils.getNoNil(fieldPlowFactor, 0);
					moFieldinfos.values.fields[index].fieldSpraySet = fieldSpraySet;
					moFieldinfos.values.fields[index].maxWeedState = maxWeedState;
					moFieldinfos.values.fields[index].fillTypeName = "*".. moLanguageXml:getTxt("wasteland", nil, "Wasteland");					
					moFieldinfos.values.fields[index].hectar = Utils.getNoNil(field.fieldArea, 0);
					moFieldinfos.values.fields[index].field = Utils.getNoNil(field.fieldId, 0);					
					moFieldinfos.values.fields[index].growth = -1;
					moFieldinfos.values.fields[index].isHarvest = 0;
					moFieldinfos.values.fields[index].isGrowth = 0;
					moFieldinfos.values.fields[index].growthTxt = "-";
					moFieldinfos.values.fields[index].growthTxtColor = moModule.values.txtColor;					
					--print("---field=".. tostring(field.fieldId))
					--print("--------------fruitType=".. tostring(field.fruitType))
					--local getfield = g_fieldManager:getFieldByIndex(field.fieldId)
					local fruitTypeIndex = Utils.getNoNil(field.fruitType, nil);
					if fruitTypeIndex == nil then
						fruitTypeIndex = Utils.getNoNil(g_fieldManager:getFruitIndexForField(field), nil);					
					end;
					if fruitTypeIndex ~= nil then						
						local fruitDesc = g_fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex)
						--local fillTypeFruit = g_fruitTypeManager.fruitTypeIndexToFillType[fruitTypeIndex];						
						if test and field.fieldId == 32 and update ~= nil and update then
							test = false;							
							--print(DebugUtil.printTableRecursively(fruitDesc, "fruitDesc ", 0, 5))
							--for _, farmLand in pairs(g_fieldManager.farmlandIdFieldMapping) do
							--	for fieldIndex, field in pairs(farmLand) do
							--		if field.fieldId == 32 then
										--print("--------------fruitType=".. tostring(field.fruitType))
							--			local fieldFruitType = moFieldinfos:findFieldFruit(field);
										--print("fieldFruitType=".. tostring(fieldFruitType))
										--print(DebugUtil.printTableRecursively(g_fieldManager.fieldStatusParametersToSet, "fieldStatus", 0, 5));
										--print(DebugUtil.printTableRecursively(field, "field 32 ", 0, 5))
							--			local fruitTypeIndex1 = Utils.getNoNil(g_fieldManager:getFruitIndexForField(field), nil);
							--			local fruitDesc1 = g_fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex1)
										--print(DebugUtil.printTableRecursively(fruitDesc1, "fruitDesc1 ", 0, 5))										
							--		end;
									--if g_farmlandManager:getFarmlandOwner(field.farmland.id) == playerFarmId then
							--			print("field ".. tostring(fieldIndex))
							--			print(DebugUtil.printTableRecursively(field, "field ", 0, 5))
							--		end;
							--	end;
							--end;
						end;
						
						local fillTypeFruitIndex = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(fruitDesc.index);
						if fillTypeFruitIndex ~= nil then
							moFieldinfos.values.fields[index].fillTypeName = moFillTypes.values.fillTypes[fruitDesc.fillType.index].name;
						else
							moFieldinfos.values.fields[index].fillTypeName = fruitDesc.fillType.title;
						end;
						moFieldinfos.values.fields[index].isHarvest = FieldUtil.getMaxHarvestState(field, fruitDesc.index);
						moFieldinfos.values.fields[index].isGrowth = FieldUtil.getMaxGrowthState(field, fruitDesc.index);
						local growthTxt, sortByGrowth, color = moFieldinfos:getFruitTypeStateText(fruitDesc.index, moFieldinfos.values.fields[index].isGrowth, moFieldinfos.values.fields[index].isHarvest)
						moFieldinfos.values.fields[index].growthTxt = growthTxt;
						if color ~= nil then moFieldinfos.values.fields[index].growthTxtColor = color;end;
						moFieldinfos.values.fields[index].growth = sortByGrowth;
					end;					
				end;
			end;
		end;		
	end;
end;

function moFieldinfos:findFieldFruit(field)
	local fieldFruitType = nil;
	--if field.fieldMissionAllowed then
		local x, z = field:getCenterOfFieldWorldPosition()

		local function testFruit(fruitType)
			local minState = 0
			local maxState = 10
			local area, totalArea = FieldUtil.getFruitArea(x - 1, z - 1, x + 1, z - 1, x - 1, z + 1, {}, {}, fruitType, minState, maxState, 0, 0, 0, false)

			return area > 0.9 * totalArea
		end

		slot5, slot6, slot7 = pairs(g_fieldManager.availableFruitTypeIndices)

		for _, fruitType in slot5, slot6, slot7 do
			if testFruit(fruitType) then
				fieldFruitType = fruitType

				break
			end
		end

		if testFruit(FruitType.GRASS) then
			fieldFruitType = FruitType.GRASS
		end
		return fieldFruitType;
	--end
end

function moFieldinfos:getFruitTypeStateTextNew(fruitTypeIndex, fruitGrowthState, fruitHarvestState)
	local text = "";
	if fruitTypeIndex > 0 then
		local fruitType = g_fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex);
		local witheredState = fruitType.maxHarvestingGrowthState+1;
		if fruitGrowthState > 0 then
			if fruitGrowthState < fruitType.maxPreparingGrowthState then
				text = "Im Wachstum 1";
			elseif fruitGrowthState == fruitType.maxPreparingGrowthState then
				text = "Im Wachstum 2";
			elseif fruitGrowthState > fruitType.maxPreparingGrowthState then
				text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);
				if fruitGrowthState >= witheredState then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_WITHERED);end;
			end;
		end;
		if string.len(text) == 0 and fruitHarvestState ~= nil then
			if fruitHarvestState <= fruitType.maxHarvestingGrowthState then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);end;
			if fruitHarvestState >= witheredState then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_WITHERED);end;
		end;
	end;
	return text;
end;

function moFieldinfos:getFruitTypeStateText(fruitTypeIndex, fruitGrowthState, fruitHarvestState)	
	local text = "";
	local color = nil;
	local sortByGrowth = -1;
	if fruitTypeIndex > 0 then --and (g_seasons == nil or MultiOverlayV3.otherMods.seasons == nil) then
		local fruitType = g_fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex);		
		local witheredState = fruitType.maxHarvestingGrowthState+1;
		if fruitType.maxPreparingGrowthState >= 0 then
			witheredState = fruitType.maxPreparingGrowthState+1;
		end;
		local maxGrowingState = fruitType.minHarvestingGrowthState-1;
		if fruitType.minPreparingGrowthState >= 0 then
			maxGrowingState = math.min(maxGrowingState, fruitType.minPreparingGrowthState-1);
		end;
		if fruitGrowthState == fruitType.cutState+1 then
			text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CUT);			 
			sortByGrowth = 0;
		elseif fruitGrowthState == witheredState+1 and g_currentMission.missionInfo.isPlantWitheringEnabled then
			text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_WITHERED);
			color = "red";
			sortByGrowth = -2;
		elseif fruitGrowthState > 0 and fruitGrowthState <= maxGrowingState+1 then
			--text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_GROWING);
			local prozent = g_i18n:formatNumber((100/(maxGrowingState+1)+0.5)*(fruitGrowthState-1));
			text = tostring(prozent).. "%";
			sortByGrowth = (100/(maxGrowingState+1)+0.5)*(fruitGrowthState-1);
		elseif fruitType.minPreparingGrowthState >= 0 and fruitType.minPreparingGrowthState <= fruitGrowthState and fruitGrowthState <= fruitType.maxPreparingGrowthState+1 then
			--text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_NEED_PREP);
			text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);
			color = "yellow";
			sortByGrowth = 100;
		elseif fruitGrowthState >= fruitType.minHarvestingGrowthState+1 and fruitGrowthState <= fruitType.maxHarvestingGrowthState+1 then
			text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);
			color = "yellow"
			sortByGrowth = 100;
		end;
		if string.len(text) == 0 and fruitHarvestState ~= nil then
			if fruitHarvestState <= fruitType.maxHarvestingGrowthState+1 then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);color="yellow";sortByGrowth=100;end;
			if fruitHarvestState > fruitType.maxHarvestingGrowthState+1 and g_currentMission.missionInfo.isPlantWitheringEnabled then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_WITHERED);color="red";sortByGrowth=-2;end;
		end;
		if string.len(text) == 0 and fruitHarvestState == nil and fruitGrowthState == 0 then
			--text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CUT);
			--sortByGrowth = 0;
		end;	
	end;
	--if fruitTypeIndex > 0 and (g_seasons ~= nil and MultiOverlayV3.otherMods.seasons ~= nil) then
	--	local fruitType = g_fruitTypeManager:getFruitTypeByIndex(fruitTypeIndex);
	--	if fruitGrowthState == MultiOverlayV3.otherMods.seasons.SeasonsGrowth.PLANTED_STATE then
	--		text = g_i18n:getText("seasons_ui_growthMapPlanted");
	--	elseif fruitGrowthState == MultiOverlayV3.otherMods.seasons.SeasonsGrowth.GERMINATION_FAILED_STATE then
	--		text = g_i18n:getText("seasons_ui_growthMapGerminationFailed");
	--	elseif fruitGrowthState == 1 then
	--		text = g_i18n:getText("seasons_ui_fruitGerminated");
	--	end;
	--	if string.len(text) == 0 and fruitHarvestState ~= nil then
	--		if fruitHarvestState <= fruitType.maxHarvestingGrowthState+1 then text = g_i18n:getText(FieldInfoDisplay.L10N_SYMBOL.GROWTH_STATE_CAN_HARVEST);end;
	--	end;
	--end;
	return text, sortByGrowth, color;
end;

local test1 = true
function moFieldinfos:onFieldDataUpdateFinished(data)
    if data == nil then return;end;
	if test1 then
		test1 = false
		print(DebugUtil.printTableRecursively(data, "data ", 0, 2))
	end;
end;

FieldInfoDisplay.onFieldDataUpdateFinished = Utils.appendedFunction(FieldInfoDisplay.onFieldDataUpdateFinished, moFieldinfos.onFieldDataUpdateFinished)