storages = {};

--needs module storages
--lineType 2/storages
function storages:load(storageName)
	local lineTable = {lineTyp=2, txtScroll={leftRight=true,upDown=true}};
	if moStorages.values.storages ~= nil and moStorages.values.storages[storageName] ~= nil then
		for storage=1, #moStorages.values.storages[storageName] do
			if moStorages.values.storages[storageName][storage] ~= nil then
				local storageGeneral = moStorages.values.storages[storageName][storage].general[1];
				lineTable[#lineTable+1] = {};
				local isLineTable = lineTable[#lineTable];
				
				if #moStorages.values.storages[storageName] > 1 and storage ~= 1 then					
					isLineTable.setLineBorderNewObject = true;	
				end;
				
				isLineTable.lineClickHelp = true;
				isLineTable.lineClickHelpCallback = storages.returnLineHelpIconClick
				isLineTable.helpTxt = "Click StorageName/%/FillLevel or .... ++ for more info (or MapHotSpot)";
				
				isLineTable.ownValues = {storageName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				local nodeId = 0;
				local foundExtension = false;
				if storageGeneral.object.storages ~= nil then 
					nodeId = Utils.getNoNil(storageGeneral.object.storages[1].rootNode, 0);
					if storageGeneral.object.storages[2] ~= nil then foundExtension = true;end;
				else
					nodeId = Utils.getNoNil(storageGeneral.object.nodeId, 0);					
				end;				
				isLineTable.txt[1].nodeId = nodeId;				
				--isLineTable.txt[1].width = 80;	--width prozent	
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtTitleColor);
				isLineTable.txt[1].bold = true;
				local extension = "";				
				if foundExtension then extension = extension.. "++";end;
				local isNearObject = moModule:nearPlayerPosition(storageGeneral.object, 20, true);				
				if isNearObject ~= nil then	isLineTable.txt[1].clickCallback = storages.returnClickObjectName;end;				
				if isNearObject ~= nil and isNearObject then
					isLineTable.txt[1].txt = ">>".. storageGeneral.objectName.. extension.. "<<";
				else
					isLineTable.txt[1].txt = storageGeneral.objectName.. extension;
				end;
				isLineTable.txt[1].txtPos = 1;
				--capacity
				lineTable[#lineTable+1] = {};
				isLineTable = lineTable[#lineTable];				
				isLineTable.ownValues = {storageName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].width = 50;	--width prozent				
				isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = moLanguageXml:getTxt("capacity", nil, "Capacity");
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 50;	--width prozent	
				isLineTable.txt[2].color = moColors:getColor(moModule.values.txtColor);
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = moLanguageXml:getTxt("per", nil, "per").. " ".. storageGeneral.capacity; --storageGeneral.percentageCapacityTotal.. "%";
				isLineTable.txt[2].txtPos = 2;
				--capacity
				--productivity1
				local color = Utils.getNoNil(moColors.prozent[storageGeneral.productivityColor], 1);								
				lineTable[#lineTable+1] = {};
				isLineTable = lineTable[#lineTable];				
				isLineTable.ownValues = {storageName};
				isLineTable.txt = {};			
				isLineTable.txt[1] = {};			
				isLineTable.txt[1].width = 50;	--width prozent				
				isLineTable.txt[1].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = storageGeneral.productivityName;
				isLineTable.txt[2] = {};			
				isLineTable.txt[2].width = 50;	--width prozent	
				isLineTable.txt[2].color = moColors:getColor(color, nil, moModule.values.txtColor);
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = storageGeneral.productivity.. "%";				
				isLineTable.txt[2].txtPos = 2;
				--productivity1
				--output
				local storageOutput = moStorages.values.storages[storageName][storage].output;
				if storageOutput ~= nil and #storageOutput > 0 then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {storageName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 100;	--width prozent
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = "Out ++";
					local buttonColor = moColors.intern["red"];
					if storageGeneral.object.viewOutput then buttonColor = moColors.intern["green"];end;
					isLineTable.txt[1].settingsButtonL = {"buttonDown", buttonColor, storages.returnClickInOutOnOff};
					isLineTable.txt[1].clickCallback = storages.returnClickInOutOnOff;
					isLineTable.txt[1].ownValues = {storageGeneral.object, false};
					if storageGeneral.object.viewOutput then						
						for output=1, #storageOutput do
							local outputTable = storageOutput[output];
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];				
							isLineTable.ownValues = {storageName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 70;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtFillTypesColor);
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = outputTable.fillTypeName;
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 30;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtAmountColor);
							isLineTable.txt[2].bold = moModule.values.txtBold;						
							isLineTable.txt[2].txt = outputTable.fillLevel;
							isLineTable.txt[2].clickCallback = storages.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(outputTable.capacity), tostring(outputTable.percentageCapacity), true};
							isLineTable.txt[2].txtPos = 2;
						end;
					end;
				end;
				--output
				--input
				local storageInput = moStorages.values.storages[storageName][storage].input;
				if storageInput ~= nil and #storageInput > 0 then
					lineTable[#lineTable+1] = {};
					isLineTable = lineTable[#lineTable];				
					isLineTable.ownValues = {storageName};
					isLineTable.txt = {};			
					isLineTable.txt[1] = {};			
					isLineTable.txt[1].width = 100;	--width prozent
					isLineTable.txt[1].color = moColors:getColor(moModule.values.txtColor);
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = "In ++";
					local buttonColor = moColors.intern["red"];
					if storageGeneral.object.viewInput then buttonColor = moColors.intern["green"];end;
					isLineTable.txt[1].settingsButtonL = {"buttonDown", buttonColor, storages.returnClickInOutOnOff};
					isLineTable.txt[1].clickCallback = storages.returnClickInOutOnOff;
					isLineTable.txt[1].ownValues = {storageGeneral.object, true};
					if storageGeneral.object.viewInput then						
						for input=1, #storageInput do
							local inputTable = storageInput[input];
							lineTable[#lineTable+1] = {};
							isLineTable = lineTable[#lineTable];				
							isLineTable.ownValues = {storageName};
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].width = 70;	--width prozent
							isLineTable.txt[1].color = moColors:getColor(moModule.values.txtNoAmountColor);
							isLineTable.txt[1].bold = moModule.values.txtBold;
							isLineTable.txt[1].txt = inputTable.fillTypeName;
							isLineTable.txt[2] = {};			
							isLineTable.txt[2].width = 30;	--width prozent
							isLineTable.txt[2].color = moColors:getColor(moModule.values.txtNoAmountColor);
							isLineTable.txt[2].bold = moModule.values.txtBold;						
							isLineTable.txt[2].txt = inputTable.fillLevel;
							isLineTable.txt[2].clickCallback = storages.returnClickFillLevelCapacityTotal;
							isLineTable.txt[2].ownValues = {tostring(inputTable.capacity), tostring(inputTable.percentageCapacity), true};
							isLineTable.txt[2].txtPos = 2;
						end;
					end;
				end;
				--input
			end;
		end;
	end;
	storages[storageName] = {output=lineTable};
end;

function storages.returnClickInOutOnOff(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then	
			local object = storages[args.ownValues[1]].output[args.line].txt[1].ownValues[1];
			local isInput = storages[args.ownValues[1]].output[args.line].txt[1].ownValues[2];
			if object ~= nil then
				if isInput and object.viewInput ~= nil then
					if object.viewInput then object.viewInput = false;else object.viewInput = true;end;
				elseif object.viewOutput ~= nil then
					if object.viewOutput then object.viewOutput = false;else object.viewOutput = true;end;
				end;
			end;
		end;
	end;
end;

function storages.returnClickFillLevelCapacityTotal(...)
	if ... ~= nil then
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then			
			local capacity = storages[args.ownValues[1]].output[args.line].txt[2].ownValues[1];
			local fillLevel = storages[args.ownValues[1]].output[args.line].txt[2].ownValues[2];
			local flipFillLevel = storages[args.ownValues[1]].output[args.line].txt[2].ownValues[3];
			--if string.len(capacity) > 0 then				
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				local capacityLanguage = moLanguageXml:getTxt("capacity", nil, "Capacity:");
				local fillcontainerLanguage = moLanguageXml:getTxt("fillcontainer", nil, "Foodtrough:");
				local prozent = ""
				if flipFillLevel ~= nil then prozent = "%";end;				
				moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. " ".. tostring(capacity).. "\n".. tostring(fillcontainerLanguage).. " ".. tostring(fillLevel).. tostring(prozent);				
			--end;
		end;
	end;
end;

function storages.returnLineHelpIconClick(...)	
	if ... ~= nil then		
		local args = ...;		
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.txt = tostring(storages[args.ownValues[1]].output[args.line].helpTxt);
		end;
	end;
end;

function storages.returnClickObjectName(...)
	if ... ~= nil then		
		local args = ...;
		if args.line ~= nil and args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local storageName = args.ownValues[1];
			if storages[storageName] ~= nil and storages[storageName].output ~= nil and storages[storageName].output[args.line] ~= nil then
				local nodeId = storages[storageName].output[args.line].txt[1].nodeId;
				local x, _, z = getWorldTranslation(nodeId);			
				moSetGetOverlays:mapHotSpot(nil, x, z);
			end;
		end;		
	end;
end;

function storages.giveOutputTable(...)	
	if ... ~= nil then
		local args = ...;
		moModule.active.storages.isRunning = true;moModule.active.storages.last = moModule.time.min+moModule.time.delay;
		if args.ownValues ~= nil and args.ownValues[1] ~= nil then
			local storageName = args.ownValues[1];
			storages:load(storageName);
			return storages[storageName].output;
		end;		
	end;
end;

function storages.reset(whichSLOT)
	if whichSLOT ~= nil and moSetGetOverlays.slot[whichSLOT] ~= nil then moSetGetOverlays.slot[whichSLOT].save = false;end;
	--storages:load();	
end;

function storages:generateCmd(storageName)
	local _, errorTable = 0, {};
	function insertCmd(storageName, objectsNodes, objectsIds)
		local newCmdTable = { insert=true, cmdOldTable=MultiOverlayV3.moduleCmdTable, cmdTable = {} };	
		local storageNameTemp = tostring(storageName):lower();
		local languageName = moLanguageXml:getTxt(storageNameTemp, nil, storageName);
		newCmdTable.cmdTable[1] = {
			cmdName = "storages_".. tostring(storageName);
			displayName = moLanguageXml:getTxt("storages", nil, "Storages").. " ".. tostring(languageName);		
			multiple = true;
			sortBy = "Storages";
			infoTxt = "Zeigt alle Storages oder diese Category an (".. tostring(languageName).. ")";
			helpTxt = "View Storages or Category";
			click = {mouseButtonLeft=true, mouseButtonMiddle=true, mouseButtonRight=true, key=true};
			lineTyp = 2;			
			typ = "output";
			action = storages.giveOutputTable; --a function
			ownValues = {storageName, objectsNodes, objectsIds}; 
		};	
		_, errorTable = moSetGetCmd:generateNewCmd(newCmdTable);
		local errorPrint = false;
		if errorPrint and #errorTable > 0 then
			for a=1, #errorTable do
				print("! ERROR ! MultiOverlayV3 Hud -->cmd generate storages Cmd error ".. tostring(a).. ": ".. tostring(errorTable[a]))
			end;
		end;
	end;
	if storageName ~= nil then 
		local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "storages_".. storageName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
		if isAlreadyExits == nil then insertCmd(storageName);end;
	else		
		if moStorages.values ~= nil then			
			for storageName, _ in pairs (moStorages.values.storages) do				
				local isAlreadyExits = moSetGetCmd:cmdFromReady(nil, "storages_".. storageName, "multioverlayV3Module", tostring(MultiOverlayV3.metadata.title), true, MultiOverlayV3.moduleCmdTable);
				if isAlreadyExits == nil then insertCmd(storageName, moModule:getObjectIds(moStorages.values.storages[storageName], true));end;
			end;
		end;
	end;	
end;